Index: LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2298)
@@ -239,6 +239,6 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: cdragm, cdragh
 !$OMP THREADPRIVATE(cdragm, cdragh)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: cldh, cldl, cldm, cldq, cldt, qsat2m, qsol
-!$OMP THREADPRIVATE(cldh, cldl, cldm, cldq, cldt, qsat2m, qsol)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: cldh, cldl, cldm, cldq, cldt, qsat2m
+!$OMP THREADPRIVATE(cldh, cldl, cldm, cldq, cldt, qsat2m )
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: cldhjn, cldljn, cldmjn,cldtjn
 !$OMP THREADPRIVATE(cldhjn, cldljn, cldmjn, cldtjn)
@@ -265,6 +265,6 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxfqcalving
 !$OMP THREADPRIVATE(zxfqcalving)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxfluxlat, zxrugs, zxtsol, snow_lsc, zxfqfonte
-!$OMP THREADPRIVATE(zxfluxlat, zxrugs, zxtsol, snow_lsc, zxfqfonte)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxfluxlat, zxtsol, snow_lsc, zxfqfonte
+!$OMP THREADPRIVATE(zxfluxlat, zxtsol, snow_lsc, zxfqfonte)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxqsurf, rain_lsc
 !$OMP THREADPRIVATE(zxqsurf, rain_lsc)
@@ -328,6 +328,6 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: fsolsw, wfbils, wfbilo
 !$OMP THREADPRIVATE(fsolsw, wfbils, wfbilo)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)  :: t2m, fevap, fluxlat, fsollw,evap_pot
-!$OMP THREADPRIVATE(t2m, fevap, fluxlat, fsollw,evap_pot)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)  :: t2m, fluxlat, fsollw,evap_pot
+!$OMP THREADPRIVATE(t2m, fluxlat, fsollw,evap_pot)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: dnwd, dnwd0, upwd, omega
 !$OMP THREADPRIVATE(dnwd, dnwd0, upwd, omega)
@@ -343,6 +343,4 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: wake_omg, zx_rh
 !$OMP THREADPRIVATE(wake_omg, zx_rh)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: frugs, agesno
-!$OMP THREADPRIVATE(frugs, agesno)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: pmflxr, pmflxs, prfl, psfl, fraca
 !$OMP THREADPRIVATE(pmflxr, pmflxs, prfl, psfl, fraca)
@@ -501,5 +499,5 @@
       ALLOCATE(ale_wake(klon), alp_wake(klon), bils(klon))
       ALLOCATE(cdragm(klon), cdragh(klon), cldh(klon), cldl(klon))
-      ALLOCATE(cldm(klon), cldq(klon), cldt(klon), qsat2m(klon), qsol(klon))
+      ALLOCATE(cldm(klon), cldq(klon), cldt(klon), qsat2m(klon))
       ALLOCATE(cldhjn(klon), cldljn(klon), cldmjn(klon), cldtjn(klon))
       ALLOCATE(JrNt(klon))
@@ -516,5 +514,5 @@
       ALLOCATE(slab_wfbils(klon), tpot(klon), tpote(klon), ue(klon))
       ALLOCATE(uq(klon), ve(klon), vq(klon), zxffonte(klon))
-      ALLOCATE(zxfqcalving(klon), zxfluxlat(klon), zxrugs(klon))
+      ALLOCATE(zxfqcalving(klon), zxfluxlat(klon))
       ALLOCATE(zxtsol(klon), snow_lsc(klon), zxfqfonte(klon), zxqsurf(klon))
       ALLOCATE(rain_lsc(klon))
@@ -557,6 +555,6 @@
       ALLOCATE(pmfd(klon, klev), pmfu(klon, klev))
 
-      ALLOCATE(t2m(klon, nbsrf), fevap(klon, nbsrf), fluxlat(klon, nbsrf))
-      ALLOCATE(frugs(klon, nbsrf), agesno(klon, nbsrf), fsollw(klon, nbsrf))
+      ALLOCATE(t2m(klon, nbsrf), fluxlat(klon, nbsrf))
+      ALLOCATE(fsollw(klon, nbsrf))
       ALLOCATE(fsolsw(klon, nbsrf), wfbils(klon, nbsrf), wfbilo(klon, nbsrf))
       ALLOCATE(evap_pot(klon, nbsrf))
@@ -701,5 +699,5 @@
       DEALLOCATE(ale_wake, alp_wake, bils)
       DEALLOCATE(cdragm, cdragh, cldh, cldl)
-      DEALLOCATE(cldm, cldq, cldt, qsat2m, qsol)
+      DEALLOCATE(cldm, cldq, cldt, qsat2m)
       DEALLOCATE(cldljn, cldmjn, cldhjn, cldtjn, JrNt)
       DEALLOCATE(dthmin, evap, fder, plcl, plfc)
@@ -714,5 +712,5 @@
       DEALLOCATE(slab_wfbils, tpot, tpote, ue)
       DEALLOCATE(uq, ve, vq, zxffonte)
-      DEALLOCATE(zxfqcalving, zxfluxlat, zxrugs)
+      DEALLOCATE(zxfqcalving, zxfluxlat)
       DEALLOCATE(zxtsol, snow_lsc, zxfqfonte, zxqsurf)
       DEALLOCATE(rain_lsc)
@@ -755,6 +753,6 @@
       DEALLOCATE(pmfd, pmfu)
 
-      DEALLOCATE(t2m, fevap, fluxlat)
-      DEALLOCATE(frugs, agesno, fsollw, evap_pot)
+      DEALLOCATE(t2m, fluxlat)
+      DEALLOCATE(fsollw, evap_pot)
       DEALLOCATE(fsolsw, wfbils, wfbilo)
 
Index: LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2298)
@@ -74,4 +74,7 @@
       ctrl_out((/ 10, 6, 10, 10, 10, 10, 11, 11, 11 /), &
     't2m_sic', "Temp 2m "//clnsurf(4), "K", (/ ('', i=1, 9) /)) /)
+
+  TYPE(ctrl_out), SAVE :: o_gusts = ctrl_out((/ 1, 1, 1, 10, 10, 10, 11, 11, 11 /), &
+    'gusts', 'surface gustiness', 'm2/s2', (/ ('', i=1, 9) /))
 
   TYPE(ctrl_out), SAVE :: o_wind10m = ctrl_out((/ 1, 1, 1, 10, 10, 10, 11, 11, 11 /), &
@@ -541,8 +544,8 @@
   TYPE(ctrl_out), SAVE :: o_proba_notrig = ctrl_out((/ 1, 1, 1, 6, 10, 10, 11, 11, 11 /), &
     'proba_notrig', &
-                         'Probabilité de non-déclenchement', ' ', (/ ('', i=1, 9) /))
+                         'Probabilite de non-declenchement', ' ', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_random_notrig = ctrl_out((/ 1, 1, 1, 6, 10, 10, 11, 11, 11 /), &
     'random_notrig', &
-                         'Tirage aléatoire de non-déclenchement', ' ', (/ ('', i=1, 9) /))
+                         'Tirage aleatoire de non-declenchement', ' ', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_ale_bl_stat = ctrl_out((/ 1, 1, 1, 6, 10, 10, 11, 11, 11 /), &
     'ale_bl_stat', &
@@ -601,5 +604,5 @@
 
   TYPE(ctrl_out), SAVE, DIMENSION(7) :: o_wSTDlevs     = (/                    &
-      ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'w850', "Vertical wind 1hPa", "Pa/s", &
+      ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'w850', "Vertical wind 850hPa", "Pa/s", &
       (/ 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)' /)), &
       ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'w700', "Vertical wind 700hPa", "Pa/s", &
@@ -617,5 +620,5 @@
 
   TYPE(ctrl_out), SAVE, DIMENSION(7) :: o_tSTDlevs     = (/                    &
-      ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'t850', "Temperature 1hPa", "K",      &
+      ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'t850', "Temperature 850hPa", "K",      &
       (/ 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)' /)), &
       ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'t700', "Temperature 700hPa", "K",      &
@@ -633,5 +636,5 @@
 
   TYPE(ctrl_out), SAVE, DIMENSION(7) :: o_qSTDlevs     = (/                             &
-      ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'q850', "Specific humidity 1hPa", &
+      ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'q850', "Specific humidity 850hPa", &
       "kg/kg", (/ 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)' /)), &
       ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'q700', "Specific humidity 700hPa", &
@@ -649,5 +652,5 @@
 
   TYPE(ctrl_out), SAVE, DIMENSION(7) :: o_zSTDlevs   = (/                           &
-      ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'z850', "Geopotential height 1hPa",        &
+      ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'z850', "Geopotential height 850hPa",        &
       "m", (/ 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)', 'inst(X)' /)), &
       ctrl_out((/ 1, 7, 7, 10, 10, 10, 11, 11, 11 /),'z700', "Geopotential height 700hPa",        &
@@ -776,6 +779,8 @@
   TYPE(ctrl_out), SAVE :: o_dtsvdfi = ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11 /), &
     'dtsvdfi', 'Boundary-layer dTs(g)', 'K/s', (/ ('', i=1, 9) /))
-  TYPE(ctrl_out), SAVE :: o_rugs = ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11 /), &
-    'rugs', 'rugosity', '-', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_z0m = ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'z0m', 'roughness length, momentum', '-', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_z0h = ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'z0h', 'roughness length, enthalpy', '-', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_topswad = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
     'topswad', 'ADE at TOA', 'W/m2', (/ ('', i=1, 9) /))
@@ -1021,9 +1026,15 @@
       ctrl_out((/ 3, 10, 10, 10, 10, 10, 11, 11, 11 /),'snow_sic',"Snow", "kg/m2", (/ ('', i=1, 9) /)) /)
 
-  TYPE(ctrl_out), SAVE, DIMENSION(4) :: o_rugs_srf     = (/ &
-      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'rugs_ter', "Surface roughness "//clnsurf(1),"m", (/ ('', i=1, 9) /)), &
-      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'rugs_lic', "Surface roughness "//clnsurf(2),"m", (/ ('', i=1, 9) /)), &
-      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'rugs_oce', "Surface roughness "//clnsurf(3),"m", (/ ('', i=1, 9) /)), &
-      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'rugs_sic', "Surface roughness "//clnsurf(4),"m", (/ ('', i=1, 9) /)) /)
+  TYPE(ctrl_out), SAVE, DIMENSION(4) :: o_z0m_srf     = (/ &
+      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'z0m_ter', "Surface roughness "//clnsurf(1),"m", (/ ('', i=1, 9) /)), &
+      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'z0m_lic', "Surface roughness "//clnsurf(2),"m", (/ ('', i=1, 9) /)), &
+      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'z0m_oce', "Surface roughness "//clnsurf(3),"m", (/ ('', i=1, 9) /)), &
+      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'z0m_sic', "Surface roughness "//clnsurf(4),"m", (/ ('', i=1, 9) /)) /)
+
+  TYPE(ctrl_out), SAVE, DIMENSION(4) :: o_z0h_srf     = (/ &
+      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'z0h_ter', "Surface roughness "//clnsurf(1),"m", (/ ('', i=1, 9) /)), &
+      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'z0h_lic', "Surface roughness "//clnsurf(2),"m", (/ ('', i=1, 9) /)), &
+      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'z0h_oce', "Surface roughness "//clnsurf(3),"m", (/ ('', i=1, 9) /)), &
+      ctrl_out((/ 3, 6, 10, 10, 10, 10, 11, 11, 11 /),'z0h_sic', "Surface roughness "//clnsurf(4),"m", (/ ('', i=1, 9) /)) /)
 
   TYPE(ctrl_out), SAVE :: o_alb1 = ctrl_out((/ 3, 10, 10, 10, 10, 10, 11, 11, 11 /), &
Index: LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2298)
@@ -32,5 +32,5 @@
          o_t2m_min_mon, o_t2m_max_mon, &
          o_q2m, o_ustar, o_u10m, o_v10m, &
-         o_wind10m, o_wind10max, o_sicf, &
+         o_wind10m, o_wind10max, o_gusts, o_sicf, &
          o_psol, o_mass, o_qsurf, o_qsol, &
          o_precip, o_ndayrain, o_plul, o_pluc, &
@@ -88,5 +88,5 @@
          o_SWdownOR, o_LWdownOR, o_snowl, &
          o_solldown, o_dtsvdfo, o_dtsvdft, &
-         o_dtsvdfg, o_dtsvdfi, o_rugs, o_od550aer, &
+         o_dtsvdfg, o_dtsvdfi, o_z0m, o_z0h, o_od550aer, &
          o_od865aer, o_absvisaer, o_od550lt1aer, &
          o_sconcso4, o_sconcno3, o_sconcoa, o_sconcbc, &
@@ -113,5 +113,5 @@
          o_zfull, o_zhalf, o_rneb, o_rnebjn, o_rnebcon, &
          o_rnebls, o_rhum, o_ozone, o_ozone_light, &
-         o_dtphy, o_dqphy, o_albe_srf, o_rugs_srf, &
+         o_dtphy, o_dqphy, o_albe_srf, o_z0m_srf, o_z0h_srf, &
          o_ages_srf, o_snow_srf, o_alb1, o_alb2, o_tke, &
          o_tke_max, o_kz, o_kz_max, o_clwcon, &
@@ -154,4 +154,5 @@
 
     USE phys_state_var_mod, only: pctsrf, paire_ter, rain_fall, snow_fall, &
+         qsol, z0m, z0h, fevap, agesno, &
          nday_rain, rain_con, snow_con, &
          topsw, toplw, toplw0, swup, swdn, &
@@ -159,5 +160,5 @@
          SWdn200, SWdn200clr, LWup200, LWup200clr, &
          LWdn200, LWdn200clr, solsw, solsw0, sollw, &
-         radsol, sollw0, sollwdown, sollw, &
+         radsol, sollw0, sollwdown, sollw, gustiness, &
          sollwdownclr, lwdn0, ftsol, ustar, u10m, &
          v10m, pbl_tke, wake_delta_pbl_TKE, &
@@ -173,14 +174,17 @@
          vqsumSTD, vTsumSTD, O3daysumSTD, wqsumSTD, &
          vphisumSTD, wTsumSTD, u2sumSTD, v2sumSTD, &
-         T2sumSTD, nlevSTD, du_gwd_rando, dv_gwd_rando
+         T2sumSTD, nlevSTD, du_gwd_rando, dv_gwd_rando, &
+         ulevSTD, vlevSTD, wlevSTD, philevSTD, qlevSTD, tlevSTD, &
+         rhlevSTD, O3STD, O3daySTD, uvSTD, vqSTD, vTSTD, wqSTD, &
+         vphiSTD, wTSTD, u2STD, v2STD, T2STD, missing_val_nf90
 
     USE phys_local_var_mod, only: zxfluxlat, slp, zxtsol, zt2m, &
-         t2m_min_mon, t2m_max_mon, &
-         zu10m, zv10m, zq2m, zustar, zxqsurf, qsol, &
-         rain_lsc, snow_lsc, evap, bils, sens, fder, &
+         t2m_min_mon, t2m_max_mon, evap, &
+         zu10m, zv10m, zq2m, zustar, zxqsurf, &
+         rain_lsc, snow_lsc, bils, sens, fder, &
          zxffonte, zxfqcalving, zxfqfonte, fluxu, &
          fluxv, zxsnow, qsnow, snowhgt, to_ice, &
          sissnow, runoff, albsol3_lic, evap_pot, &
-         t2m, fevap, fluxt, fluxlat, fsollw, fsolsw, &
+         t2m, fluxt, fluxlat, fsollw, fsolsw, &
          wfbils, wfbilo, cdragm, cdragh, cldl, cldm, &
          cldh, cldt, JrNt, cldljn, cldmjn, cldhjn, &
@@ -197,5 +201,5 @@
          weak_inversion, dthmin, cldtau, cldemi, &
          pmflxr, pmflxs, prfl, psfl, re, fl, rh2m, &
-         qsat2m, tpote, tpot, d_ts, zxrugs, od550aer, &
+         qsat2m, tpote, tpot, d_ts, od550aer, &
          od865aer, absvisaer, od550lt1aer, sconcso4, sconcno3, &
          sconcoa, sconcbc, sconcss, sconcdust, concso4, concno3, &
@@ -211,6 +215,10 @@
          lcc, lcc3d, lcc3dcon, lcc3dstra, reffclwtop, &
          ec550aer, flwc, fiwc, t_seri, theta, q_seri, &
-         ql_seri, zphi, u_seri, v_seri, omega, cldfra, &
-         rneb, rnebjn, zx_rh, frugs, agesno, d_t_dyn, d_q_dyn, &
+!jyg<
+!!         ql_seri, zphi, u_seri, v_seri, omega, cldfra, &
+         ql_seri, tr_seri, &
+         zphi, u_seri, v_seri, omega, cldfra, &
+!>jyg
+         rneb, rnebjn, zx_rh, d_t_dyn, d_q_dyn, &
          d_u_dyn, d_v_dyn, d_t_con, d_t_ajsb, d_t_ajs, &
          d_u_ajs, d_v_ajs, &
@@ -243,5 +251,5 @@
     ! ug Pour les sorties XIOS
     USE xios, ONLY: xios_update_calendar
-    USE wxios, only: wxios_closedef
+    USE wxios, only: wxios_closedef, missing_val
 #endif
     USE phys_cal_mod, only : mth_len
@@ -289,5 +297,8 @@
     INTEGER, DIMENSION(iim*jjmp1*klev) :: ndex3d
     REAL, PARAMETER :: dobson_u = 2.1415e-05 ! Dobson unit, in kg m-2
-    REAL, PARAMETER :: missing_val=nf90_fill_real
+!   REAL, PARAMETER :: missing_val=nf90_fill_real
+#ifndef CPP_XIOS
+    REAL :: missing_val
+#endif
     REAL, PARAMETER :: un_jour=86400.
 
@@ -354,4 +365,6 @@
        ENDIF
        CALL histwrite_phy(o_wind10max, zx_tmp_fi2d)
+
+       CALL histwrite_phy(o_gusts, gustiness)
 
        IF (vars_defined) THEN
@@ -566,5 +579,5 @@
           ENDIF
 !jyg<
-          IF (iflag_pbl > 1) THEN
+          IF (iflag_pbl > 1 .AND. iflag_wake>=1  .AND. iflag_pbl_split >=1) THEN
              CALL histwrite_phy(o_dltpbltke_srf(nsrf), wake_delta_pbl_TKE(:,1:klev,nsrf))
           ENDIF
@@ -655,6 +668,10 @@
        !       ENDIF
 
+#ifdef CPP_IOIPSL
+#ifndef CPP_XIOS
+  IF (.NOT.ok_all_xml) THEN
        ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
        ! Champs interpolles sur des niveaux de pression
+       missing_val=missing_val_nf90
        DO iff=1, nfiles
           ll=0
@@ -678,5 +695,29 @@
           ENDDO
        ENDDO
-
+  ENDIF
+#endif
+#endif
+#ifdef CPP_XIOS
+  IF(ok_all_xml) THEN
+!XIOS  CALL xios_get_field_attr("u850",default_value=missing_val)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+          ll=0
+          DO k=1, nlevSTD
+             bb2=clevSTD(k) 
+             IF(bb2.EQ."850".OR.bb2.EQ."700".OR. &
+                bb2.EQ."500".OR.bb2.EQ."200".OR. &
+                bb2.EQ."100".OR. &
+                bb2.EQ."50".OR.bb2.EQ."10") THEN
+                ll=ll+1
+                CALL histwrite_phy(o_uSTDlevs(ll),ulevSTD(:,k))
+                CALL histwrite_phy(o_vSTDlevs(ll),vlevSTD(:,k))
+                CALL histwrite_phy(o_wSTDlevs(ll),wlevSTD(:,k))
+                CALL histwrite_phy(o_zSTDlevs(ll),philevSTD(:,k))
+                CALL histwrite_phy(o_qSTDlevs(ll),qlevSTD(:,k))
+                CALL histwrite_phy(o_tSTDlevs(ll),tlevSTD(:,k))
+             ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.
+          ENDDO
+  ENDIF
+#endif
        IF (vars_defined) THEN
           DO i=1, klon
@@ -720,9 +761,10 @@
              CALL histwrite_phy(o_dqwak, zx_tmp_fi3d)
           ENDIF ! iflag_wake>=1
-          CALL histwrite_phy(o_Vprecip, Vprecip)
           CALL histwrite_phy(o_ftd, ftd)
           CALL histwrite_phy(o_fqd, fqd)
-       ELSEIF (iflag_con.EQ.30) THEN
+       ENDIF !(iflag_con.EQ.3)
+       IF (iflag_con.EQ.3.OR.iflag_con.EQ.30) THEN
           ! sortie RomP convection descente insaturee iflag_con=30
+          ! etendue a iflag_con=3 (jyg)
           CALL histwrite_phy(o_Vprecip, Vprecip)
           CALL histwrite_phy(o_wdtrainA, wdtrainA)
@@ -808,5 +850,6 @@
        CALL histwrite_phy(o_dtsvdfg,  d_ts(:,is_lic))
        CALL histwrite_phy(o_dtsvdfi, d_ts(:,is_sic))
-       CALL histwrite_phy(o_rugs, zxrugs)
+       CALL histwrite_phy(o_z0m, z0m(:,nbsrf+1))
+       CALL histwrite_phy(o_z0h, z0h(:,nbsrf+1))
        ! OD550 per species
 !--OLIVIER
@@ -973,6 +1016,8 @@
           IF (vars_defined) zx_tmp_fi2d(1 : klon) = falb1( 1 : klon, nsrf)
           CALL histwrite_phy(o_albe_srf(nsrf), zx_tmp_fi2d)
-          IF (vars_defined) zx_tmp_fi2d(1 : klon) = frugs( 1 : klon, nsrf)
-          CALL histwrite_phy(o_rugs_srf(nsrf), zx_tmp_fi2d)
+          IF (vars_defined) zx_tmp_fi2d(1 : klon) = z0m( 1 : klon, nsrf)
+          CALL histwrite_phy(o_z0m_srf(nsrf), zx_tmp_fi2d)
+          IF (vars_defined) zx_tmp_fi2d(1 : klon) = z0h( 1 : klon, nsrf)
+          CALL histwrite_phy(o_z0h_srf(nsrf), zx_tmp_fi2d)
           IF (vars_defined) zx_tmp_fi2d(1 : klon) = agesno( 1 : klon, nsrf)
           CALL histwrite_phy(o_ages_srf(nsrf), zx_tmp_fi2d)
@@ -1267,4 +1312,10 @@
        ENDIF
 !!!!!!!!!!!! Sorties niveaux de pression NMC !!!!!!!!!!!!!!!!!!!!
+#ifdef CPP_IOIPSL
+#ifndef CPP_XIOS
+  IF (.NOT.ok_all_xml) THEN 
+       ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
+       ! Champs interpolles sur des niveaux de pression
+       missing_val=missing_val_nf90
        DO iff=7, nfiles
 
@@ -1330,4 +1381,74 @@
           CALL histwrite_phy(o_TxT,T2sumSTD(:,:,iff-6),iff)
        ENDDO !nfiles
+  ENDIF
+#endif
+#endif
+#ifdef CPP_XIOS
+  IF(ok_all_xml) THEN 
+!      DO iff=7, nfiles
+
+!         CALL histwrite_phy(o_tnondef,tnondef(:,:,3))
+          CALL histwrite_phy(o_ta,tlevSTD(:,:))
+          CALL histwrite_phy(o_zg,philevSTD(:,:))
+          CALL histwrite_phy(o_hus,qlevSTD(:,:))
+          CALL histwrite_phy(o_hur,rhlevSTD(:,:))
+          CALL histwrite_phy(o_ua,ulevSTD(:,:))
+          CALL histwrite_phy(o_va,vlevSTD(:,:))
+          CALL histwrite_phy(o_wap,wlevSTD(:,:))
+!         IF(vars_defined) THEN
+!            DO k=1, nlevSTD
+!               DO i=1, klon
+!                  IF(tnondef(i,k,3).NE.missing_val) THEN
+!                     IF(freq_outNMC(iff-6).LT.0) THEN
+!                        freq_moyNMC(iff-6)=(mth_len*un_jour)/freq_calNMC(iff-6)
+!                     ELSE
+!                        freq_moyNMC(iff-6)=freq_outNMC(iff-6)/freq_calNMC(iff-6)
+!                     ENDIF
+!                     zx_tmp_fi3d_STD(i,k) = (100.*tnondef(i,k,3))/freq_moyNMC(iff-6)
+!                  ELSE
+!                     zx_tmp_fi3d_STD(i,k) = missing_val
+!                  ENDIF
+!               ENDDO
+!            ENDDO
+!         ENDIF
+!         CALL histwrite_phy(o_psbg,zx_tmp_fi3d_STD)
+          IF(vars_defined) THEN
+             DO k=1, nlevSTD
+                DO i=1, klon
+                   IF(O3STD(i,k).NE.missing_val) THEN
+                      zx_tmp_fi3d_STD(i,k) = O3STD(i,k) * 1.e+9
+                   ELSE
+                      zx_tmp_fi3d_STD(i,k) = missing_val
+                   ENDIF
+                ENDDO
+             ENDDO !k=1, nlevSTD
+          ENDIF
+          CALL histwrite_phy(o_tro3,zx_tmp_fi3d_STD)
+          if (read_climoz == 2) THEN
+             IF(vars_defined) THEN
+                DO k=1, nlevSTD
+                   DO i=1, klon
+                      IF(O3daySTD(i,k).NE.missing_val) THEN
+                         zx_tmp_fi3d_STD(i,k) = O3daySTD(i,k) * 1.e+9
+                      ELSE
+                         zx_tmp_fi3d_STD(i,k) = missing_val
+                      ENDIF
+                   ENDDO
+                ENDDO !k=1, nlevSTD
+             ENDIF
+             CALL histwrite_phy(o_tro3_daylight,zx_tmp_fi3d_STD)
+          endif
+          CALL histwrite_phy(o_uxv,uvSTD(:,:))
+          CALL histwrite_phy(o_vxq,vqSTD(:,:))
+          CALL histwrite_phy(o_vxT,vTSTD(:,:))
+          CALL histwrite_phy(o_wxq,wqSTD(:,:))
+          CALL histwrite_phy(o_vxphi,vphiSTD(:,:))
+          CALL histwrite_phy(o_wxT,wTSTD(:,:))
+          CALL histwrite_phy(o_uxu,u2STD(:,:))
+          CALL histwrite_phy(o_vxv,v2STD(:,:))
+          CALL histwrite_phy(o_TxT,T2STD(:,:))
+!      ENDDO !nfiles
+  ENDIF
+#endif
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         IF (nqtot.GE.nqo+1) THEN
@@ -1335,5 +1456,8 @@
               IF (type_trac == 'lmdz' .OR. type_trac == 'repr') THEN
 
-             CALL histwrite_phy(o_trac(iq-nqo), qx(:,:,iq))
+!jyg<
+!!             CALL histwrite_phy(o_trac(iq-nqo), qx(:,:,iq))
+             CALL histwrite_phy(o_trac(iq-nqo), tr_seri(:,:,iq-nqo))
+!>jyg
              CALL histwrite_phy(o_dtr_vdf(iq-nqo),d_tr_cl(:,:,iq-nqo))
              CALL histwrite_phy(o_dtr_the(iq-nqo),d_tr_th(:,:,iq-nqo))
@@ -1352,5 +1476,8 @@
              IF(vars_defined) THEN
                 DO k=1,klev
-                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*qx(:,k,iq)
+!jyg<
+!!                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*qx(:,k,iq)
+                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,iq-nqo)
+!>jyg
                 ENDDO
              ENDIF
Index: LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2298)
@@ -10,4 +10,5 @@
 ! Declaration des variables
       USE dimphy
+      USE netcdf, only: nf90_fill_real
       INTEGER, PARAMETER :: nlevSTD=17
       INTEGER, PARAMETER :: nlevSTD8=8
@@ -16,4 +17,5 @@
       INTEGER, PARAMETER :: napisccp=1
       INTEGER, SAVE :: radpas
+      REAL, PARAMETER :: missing_val_nf90=nf90_fill_real
 !$OMP THREADPRIVATE(radpas)
       REAL, SAVE :: dtime, solaire_etat0
@@ -24,4 +26,6 @@
       REAL, ALLOCATABLE, SAVE :: ftsol(:,:)
 !$OMP THREADPRIVATE(ftsol)
+      REAL,ALLOCATABLE,SAVE :: qsol(:),fevap(:,:),z0m(:,:),z0h(:,:),agesno(:,:)
+!$OMP THREADPRIVATE(qsol,fevap,z0m,z0h,agesno)
 !      character(len=6), SAVE :: ocean
 !!!!!!$OMP THREADPRIVATE(ocean)
@@ -304,4 +308,6 @@
       REAL,ALLOCATABLE,SAVE :: sollwdown(:)
 !$OMP THREADPRIVATE(sollwdown)
+      REAL,ALLOCATABLE,SAVE :: gustiness(:)
+!$OMP THREADPRIVATE(gustiness)
       REAL,ALLOCATABLE,SAVE :: sollwdownclr(:)
 !$OMP THREADPRIVATE(sollwdownclr)
@@ -416,4 +422,6 @@
       ALLOCATE(pctsrf(klon,nbsrf))
       ALLOCATE(ftsol(klon,nbsrf))
+      ALLOCATE(qsol(klon),fevap(klon,nbsrf))
+      ALLOCATE(z0m(klon,nbsrf+1),z0h(klon,nbsrf+1),agesno(klon,nbsrf))
       ALLOCATE(falb1(klon,nbsrf))
       ALLOCATE(falb2(klon,nbsrf))
@@ -544,4 +552,5 @@
       ALLOCATE(albplap(klon))
       ALLOCATE(solswp(klon), sollwp(klon))
+      ALLOCATE(gustiness(klon))
       ALLOCATE(sollwdownp(klon))
       ALLOCATE(topsw0p(klon),toplw0p(klon))
@@ -586,4 +595,5 @@
 
       deallocate(rlat, rlon, pctsrf, ftsol, falb1, falb2)
+      deallocate(qsol,fevap,z0m,z0h,agesno)
       deallocate(rain_fall, snow_fall, solsw, sollw, radsol)
       deallocate(zmea, zstd, zsig, zgam)
@@ -664,4 +674,5 @@
       deallocate(topsw, toplw)
       deallocate(sollwdown, sollwdownclr)
+      deallocate(gustiness)
       deallocate(toplwdown, toplwdownclr)
       deallocate(topsw0,toplw0,solsw0,sollw0)
